/* =========================================================================================================
  Script Spawn Group - ArmA3
  Version	: 1.0
  Date 		: 02/07/2018
  Auteur	: The-KiLLeR (www.clan-ado.fr / killouze@hotmail.fr)
========================================================================================================= */
if (!isServer) exitWith {};

/*
	Commande  utiliser dans un dclencheur :
		[["MARQUEUR1","MARQUEUR2"],"TYPE-GROUPE","VITESSE",REPETITION] call ADO_FNC_renforts;
	
	Exemple :
		[["m1","m2","m3"],"OI_reconPatrol","NORMAL",true] call ADO_FNC_renforts;
	
	-------------------------------------
	
	Argument 1 (Array) : Nom des marqueurs (1er = position dpart)
	Argument 2 (String) : Type de groupe (Voir liste ci-dessous)
	Argument 3 (String) : Vitesse du groupe (Voir liste ci-dessous)
	Argument 4 (Bool)	: Rpetition de la patrouille (true = oui, false = non)
	
	LISTE DES GROUPES :
	
		A vous de les dfinirs ci-dessous
		
	LISTE DES VITESSE :
	
		NORMAL : Vitesse lente
		RAPIDE : Vitesse rapide
*/

private ["_pos1","_pos","_type","_cycle","_unites","_groupe","_side","_vitesse"];

_pos 		= _this select 0;
_pos1 		= getMarkerPos(_pos select 0);
_type 		= _this select 1;
_vitesse 	= _this select 2;
_cycle	 	= _this select 3;
 
// ====================================== RENSEIGNER LES INFORMATIONS SUIVANTES ======================================

_unites = switch (_type) do {
	case "CUP_O_TK_MILITIA_Patrol" 	: { configfile >> "CfgGroups" >> "East" >> "CUP_O_TK_MILITIA" >> "Infantry" >> "CUP_O_TK_MILITIA_Patrol" };
	case "CUP_O_TK_MILITIA_Group" 	: { configfile >> "CfgGroups" >> "East" >> "CUP_O_TK_MILITIA" >> "Infantry" >> "CUP_O_TK_MILITIA_Group" };
	case "OI_reconTeam" 	: { configfile >> "CfgGroups" >> "East" >> "OPF_F" >> "Infantry" >> "OI_reconTeam" };
	case "group_template_1" : { "custom" };
};

// ====================================== NE PAS TOUCHER ======================================

if (typeName _unites == "STRING") then
{
	_side = call compile format["side %1",_type];
	_base = switch (_side) do {
		case WEST : { "B_Soldier_F" };
		case EAST : { "O_Soldier_F" };
		case RESISTANCE : { "I_Soldier_F" };
	};
	
	_nb = call compile format["count units %1",_type];
	
	_baseList = [];
	 for [{_i=0}, {_i < _nb}, {_i = _i + 1}] do
	{
		_baseList = _baseList + [_base];
	};
	
	_identities = missionNamespace getVariable format["ADO_RENFORTS_%1",_type];
	
	_groupe = [_pos1, _side, _baseList,[],[],[0.1,0.3]] call BIS_fnc_spawnGroup;
	_newUnits = units _groupe;

	 for [{_i=0}, {_i < _nb}, {_i = _i + 1}] do
	{
		[_newUnits select _i, [missionNamespace, format["ADO_RENFORTS_%1_%2",_type,_i]]] call BIS_fnc_loadInventory;
		if (_identities select _i != "") then { (_newUnits select _i) setIdentity (_identities select _i); };
	};
}
else
{
	_sideNb = getNumber(_unites >> "side");
	_side = switch (_sideNb) do {
		case 0 : { EAST };
		case 1 : { WEST };
		case 2 : { RESISTANCE };
	};
	_groupe = [_pos1, _side, _unites,[],[],[0.1,0.3]] call BIS_fnc_spawnGroup;
};

{
	_x setCombatMode "RED";
	_x setFormation "COLUMN";
	
	switch (_vitesse) do {
		case "NORMAL" : {_x setSpeedMode "LIMITED"; _x setBehaviour "SAFE";};
		case "RAPIDE" : {_x setSpeedMode "FULL";};
	};

} forEach units _groupe;

[units _groupe] execVM "scripts\ado_setskill.sqf";

_groupe deleteGroupWhenEmpty true;

_i = 0;
{
	if (_i > 0) then
	{
		_groupe addWaypoint [getMarkerPos(_pos select _i), _i];
		[_groupe,_i] setWaypointType "MOVE";	
	};
	
	_i = _i + 1;
	
} foreach _pos;

if (_cycle) then {
	_groupe addWaypoint [_pos1, _i];
	[_groupe,_i] setWaypointType "CYCLE";	
};

if (true) exitWith {};